Protocole de NetworkAPI
====================
Ce fichier dfini simplement le fonctionnement du protocole qui sera implment dans le package `net.mc_pandacraft.java.plugin.pandacraftutils.network_api`

Il servira  faire communiquer le serveur Minecraft avec l'interface d'administration ou le site internet

## Type de connexion
Connexion TCP


## Cryptage
Les communications devant rester dans un rseau priv (loopback, VNP) entre les systmes composant le serveur, il n'est pas vraiment ncessaire de crypter les connexions. En d'autres termes, les clients effectuant les requtes ne correspondent pas aux utilisateurs finaux, se trouvant sur les rseaux d'accs.

## Scurit
Mme si le cryptage ne semble pas ncessaire, il faut tout de mme scuriser avec un systme de "mot de passe", qui sera dcrit en dessous

## Structure d'une requte
La requte est construite en mode texte, sur plusieurs lignes. Chaque ligne se fini par un '\n' :

 - Mot de passe alphanumrique + '\n'
 - Commande principale + '\n'
 - Longueur des donnes, en octets + '\n'
 - Valeur/donnes (pas de '\n'  la fin)
 
 Pour que l'analyse de la requte ct serveur puisse s'effectuer ct serveur, le flux qui va du client vers le serveur doit tre ferme aprs envoi des donnes.

### Exemple de paquet
    ervg1e3r2c
    command
    12
    say Salut :)


### Les commandes principaux

#### `command`
Excute la commande passe dans la partie **donne** de la requte, comme si elle avait t excute par la console (`ConsoleCommandSender` dans Bukkit). Le rsultat de l'excution de la commande (valeur de retour de CommandExecutor.onCommand()) ne peux pas tre retourn en rponse. Cependant, la non excution de la commande sera indiqu dans la console du serveur

#### `command_async`
Pareil que `command` mais cette fois, celle-ci n'est pas forcment excute dans le thread principal. Attention : certaines commandes ne peuvent pas fonctionner en asynchrone. Cette mthode est utile dans le cas o le thread principal ne rpond plus

#### `broadcast`
Affiche un message sur le chat pour tout le monde connect.
Le message pass dans la partie **donne** est diffus tel quel dans le chat et sur la console (attention  la bonne utilisation des codes couleurs)

#### `player_list`
Renvoi la liste des joueurs connects. La valeur pass dans la partie **donne** doit contenir, selon les besoins :

- `disp_name` pour donner les noms d'affichage du genre [Admin]Pseudo
- `location` pour donner la localisation du joueur
- `ip` pour donner l'IP du joueur
- ...

## Structure d'une rponse
La rponse est construite en mode texte, sur plusieurs lignes. Chaque ligne se fini par un '\n' :

- Status de rponse (`OK` ou `ERROR`) + '\n'
- Longueur des donnes
- Donnes, si ncessaire,ou message d'erreur, si status != `ok`

### Exemple de paquets
Rponse  une requte sans rsultat qui a bien t excut

    OK
    0
 ----
Rponse  une commande inexistante

    ERROR
    24
    command_not_exists
 ----
Rponse  une requte de type `player_list`

    OK
    56
    player\0disp_name
    marcbal\0f[4Adminf]4marcbalr

